import gconf
import rb

GPM_SETTINGS_PATH = "/apps/gnome-power-manager/buttons/"
LID_AC_PATH = GPM_SETTINGS_PATH + "lid_ac"
LID_BAT_PATH = GPM_SETTINGS_PATH + "lid_battery"

class RBLaptopLidPlugin(rb.Plugin):
	def __init__(self):
		rb.Plugin.__init__(self)
		self.gconf = gconf.client_get_default()
		self.sig_id = None
		self.lid_ac = None
		self.lid_bat = None

	def activate(self, shell):
		self.lid_ac = self.gconf.get_string(LID_AC_PATH)
		self.lid_bat = self.gconf.get_string(LID_BAT_PATH)
		player = shell.get_player()
		self.sig_id = player.connect("playing_changed", self.playing_changed)

	def deactivate(self, shell):
		player = shell.get_player()
		player.disconnect(self.sig_id)
		self.write_settings(self.lid_ac, self.lid_bat)
		del self.gconf

	def playing_changed(self, player, is_playing):
		lid_ac = lid_bat = "nothing"
		if not is_playing:
			lid_ac = self.lid_ac
			lid_bat = self.lid_bat
		self.write_settings(lid_ac, lid_bat)
	
	def write_settings(self, lid_ac, lid_bat):
		self.gconf.set_string(LID_AC_PATH, lid_ac)
		self.gconf.set_string(LID_BAT_PATH, lid_bat)
